# My projects Terraform repo

It focuses on VMWare but you can find
other examples in the `./examples` folder.

[Example documentation](https://docs.k8s-01.sch.bme.hu/tutorials/terraform#learn-by-doing-it)

Each file contains on top what it should be used for.

## Initialize

We should store our terraform state in some remote 
location, because this way others can work with
our project.
For that you should create your `login.sh` in the
`secret` folder by copying the `login.sh.example` file.
You will need an Acces token with `api` scope for your
repository which can be created under 
`Settings` > `Access tokens`.
If you don't want to create a token for each project
just create one for your user and use that.

After you created the `login.sh` file, just run the `bootstrap.sh`
file which configures the repository and your environment.

`Infrastructure` should be enabled for the Repository!

## Usage

This will load the environment variables for the Vsphere provider.

### Example

First time:

```bash
cp secret/login.sh.example secret/login.sh
nano secret/login.sh
# ...
./bootstrap.sh
terraform plan
```

After it was initialized:

```bash
./bootstrap.sh
terraform plan
```

## Cloud-init

We can pass initialization script to our vms using
cloud-init. 
In this repo you can find an example to it
under the `cloud-init` folder. 
We can then base64 the file content and pass it as a 
`vApp` property. 

https://cloudinit.readthedocs.io/en/latest/

