# Everything that is used for configuration

terraform {
  required_providers {
    # List of providers
    vsphere = {
      source  = "hashicorp/vsphere"
      version = "2.0.2"
    }
    template = {
      source  = "hashicorp/template"
      version = "2.2.0"
    }
  }
  backend "http" {
    # Store our State in the Gitlab Repo
  }
}

# Example: Vsphere provider config

# Credentials are set by sourcing the secret/login.sh file
variable "vsphere_user" {
  description = "Administrator user"
  type        = string
  sensitive   = false
  default     = "required"
}

variable "vsphere_password" {
  description = "Administrator password"
  type        = string
  sensitive   = true
  default     = "required"
}

provider "vsphere" {
  user           = var.vsphere_user
  password       = var.vsphere_password
  vsphere_server = "horizont.sch.bme.hu"

  # We use letsencrypt and that isn't verified somehow
  allow_unverified_ssl = true
}
